#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "Bits", Category = "Value", Help = "extracts specified bits from an integer value", Tags = "binary")]
	#endregion PluginInfo
	public class ValueBitsNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("Input", DefaultValue = 1)]
		ISpread<int> FInput;

		[Input("Bit", DefaultValue = 1)]
		ISpread<int> FBitInput;			
		
		[Output("Output")]
		ISpread<bool> FOutput;
		
		[Output("Inverse Output")]
		ISpread<bool> FOutputInverse;

		[Import()]
		ILogger FLogger;
		#endregion fields & pins

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			int FInputCount = FInput.SliceCount;
			int FBitInputCount = FBitInput.SliceCount;
			bool tmpBool = false;
			
			FOutput.SliceCount = FInputCount * FBitInputCount;
			FOutputInverse.SliceCount = FInputCount * FBitInputCount;
			for (int i = 0; i < FInputCount; i++) 
			{
				for (int j = 0; j < FBitInputCount; j++) 
				{
					if ((((int)FInput[i] >> FBitInput[j]) & 1) > 0){
						tmpBool = true;
					} else
					{
						tmpBool = false;
					}
				
					FOutput[(i*FBitInputCount)+j] = tmpBool;
					FOutputInverse[(i*FBitInputCount)+j] = !tmpBool;
				}
			}
		}
		
	}
}
